/*
 * GMS REST API
 * Date: 2019-06-28 10:13:53 | Number of web services: 176
 *
 * OpenAPI spec version: 3.1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;
import io.swagger.client.model.GatewayEventDto;
import io.swagger.client.model.LastEventDto;
import io.swagger.client.model.LastOperationDto;
import io.swagger.client.model.GatewaysStatisticDto;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.ErrorDto;
import io.swagger.client.model.FleetDto;
import io.swagger.client.model.FleetLastEventCounterDto;
import io.swagger.client.model.PaginatedDto;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class FleetsApi {
    private ApiClient apiClient;

    public FleetsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public FleetsApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for createFleet
     * @param body The DTO JSON representation to put in the request body (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createFleetCall(FleetDto body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/gms/application/fleets";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createFleetValidateBeforeCall(FleetDto body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling createFleet(Async)");
        }
        
        com.squareup.okhttp.Call call = createFleetCall(body, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createFleet
     * This web service allows to create a new fleet.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public String createFleet(FleetDto body) throws ApiException {
        ApiResponse<String> resp = createFleetWithHttpInfo(body);
        return resp.getData();
    }

    /**
     * createFleet
     * This web service allows to create a new fleet.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<String> createFleetWithHttpInfo(FleetDto body) throws ApiException {
        com.squareup.okhttp.Call call = createFleetValidateBeforeCall(body, null, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * createFleet (asynchronously)
     * This web service allows to create a new fleet.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createFleetAsync(FleetDto body, final ApiCallback<String> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createFleetValidateBeforeCall(body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for deleteFleet
     * @param id Fleet identifier (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call deleteFleetCall(Long id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/fleets/{id}"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call deleteFleetValidateBeforeCall(Long id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling deleteFleet(Async)");
        }
        
        com.squareup.okhttp.Call call = deleteFleetCall(id, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * deleteFleet
     * This web service allows to delete one fleet.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param id Fleet identifier (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void deleteFleet(Long id) throws ApiException {
        deleteFleetWithHttpInfo(id);
    }

    /**
     * deleteFleet
     * This web service allows to delete one fleet.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param id Fleet identifier (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> deleteFleetWithHttpInfo(Long id) throws ApiException {
        com.squareup.okhttp.Call call = deleteFleetValidateBeforeCall(id, null, null);
        return apiClient.execute(call);
    }

    /**
     * deleteFleet (asynchronously)
     * This web service allows to delete one fleet.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param id Fleet identifier (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deleteFleetAsync(Long id, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deleteFleetValidateBeforeCall(id, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for getFleet
     * @param id Fleet identifier (required)
     * @param fields List of fields to display (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getFleetCall(Long id, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/fleets/{id}"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getFleetValidateBeforeCall(Long id, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getFleet(Async)");
        }
        
        com.squareup.okhttp.Call call = getFleetCall(id, fields, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getFleet
     * This web service allows to retrieve one fleet.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Fleet identifier (required)
     * @param fields List of fields to display (optional)
     * @return FleetDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public FleetDto getFleet(Long id, String fields) throws ApiException {
        ApiResponse<FleetDto> resp = getFleetWithHttpInfo(id, fields);
        return resp.getData();
    }

    /**
     * getFleet
     * This web service allows to retrieve one fleet.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Fleet identifier (required)
     * @param fields List of fields to display (optional)
     * @return ApiResponse&lt;FleetDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<FleetDto> getFleetWithHttpInfo(Long id, String fields) throws ApiException {
        com.squareup.okhttp.Call call = getFleetValidateBeforeCall(id, fields, null, null);
        Type localVarReturnType = new TypeToken<FleetDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getFleet (asynchronously)
     * This web service allows to retrieve one fleet.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Fleet identifier (required)
     * @param fields List of fields to display (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getFleetAsync(Long id, String fields, final ApiCallback<FleetDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getFleetValidateBeforeCall(id, fields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<FleetDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getFleetEvents
     * @param endDate The end date of the period (required)
     * @param id Fleet identifier (required)
     * @param startDate The start date of the period (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param type Event type :  {CPU_ON, CPU_OFF, DISK_SYSTEM_ON, DISK_SYSTEM_OFF, DISK_USER_ON, DISK_USER_OFF, DOOR_OPEN, DOOR_CLOSED, DOOR_NOT_APPLICABLE, GPS_UNLOCKED, GPS_LOCKED, GPS_NOT_APPLICABLE, RAM_ON, RAM_OFF, RSSI_ON, RSSI_OFF, TEMPERATURE_ON, TEMPERATURE_OFF, START, SHUTDOWN, RESTART, POWER_LOST, AUTOMATIC_SYSTEM_RESTORATION, AUTOMATIC_SYSTEM_RESTORATION_FACTORY, PREVIOUS_CONFIG_RESTORATION, HELLO, SNMP_AUTHENTICATION_FAILURE, CONNECTED, DISCONNECTED} (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getFleetEventsCall(String endDate, Long id, String startDate, String fields, String page, String pageSize, String type, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/fleets/{id}/events"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (endDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("endDate", endDate));
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("pageSize", pageSize));
        if (startDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("startDate", startDate));
        if (type != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("type", type));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getFleetEventsValidateBeforeCall(String endDate, Long id, String startDate, String fields, String page, String pageSize, String type, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'endDate' is set
        if (endDate == null) {
            throw new ApiException("Missing the required parameter 'endDate' when calling getFleetEvents(Async)");
        }
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getFleetEvents(Async)");
        }
        // verify the required parameter 'startDate' is set
        if (startDate == null) {
            throw new ApiException("Missing the required parameter 'startDate' when calling getFleetEvents(Async)");
        }
        
        com.squareup.okhttp.Call call = getFleetEventsCall(endDate, id, startDate, fields, page, pageSize, type, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getFleetEvents
     * This web service allows to retrieve the list of the events of one fleet.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param endDate The end date of the period (required)
     * @param id Fleet identifier (required)
     * @param startDate The start date of the period (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param type Event type :  {CPU_ON, CPU_OFF, DISK_SYSTEM_ON, DISK_SYSTEM_OFF, DISK_USER_ON, DISK_USER_OFF, DOOR_OPEN, DOOR_CLOSED, DOOR_NOT_APPLICABLE, GPS_UNLOCKED, GPS_LOCKED, GPS_NOT_APPLICABLE, RAM_ON, RAM_OFF, RSSI_ON, RSSI_OFF, TEMPERATURE_ON, TEMPERATURE_OFF, START, SHUTDOWN, RESTART, POWER_LOST, AUTOMATIC_SYSTEM_RESTORATION, AUTOMATIC_SYSTEM_RESTORATION_FACTORY, PREVIOUS_CONFIG_RESTORATION, HELLO, SNMP_AUTHENTICATION_FAILURE, CONNECTED, DISCONNECTED} (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<GatewayEventDto> getFleetEvents(String endDate, Long id, String startDate, String fields, String page, String pageSize, String type) throws ApiException {
        ApiResponse<PaginatedDto<GatewayEventDto>> resp = getFleetEventsWithHttpInfo(endDate, id, startDate, fields, page, pageSize, type);
        return resp.getData();
    }

    /**
     * getFleetEvents
     * This web service allows to retrieve the list of the events of one fleet.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param endDate The end date of the period (required)
     * @param id Fleet identifier (required)
     * @param startDate The start date of the period (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param type Event type :  {CPU_ON, CPU_OFF, DISK_SYSTEM_ON, DISK_SYSTEM_OFF, DISK_USER_ON, DISK_USER_OFF, DOOR_OPEN, DOOR_CLOSED, DOOR_NOT_APPLICABLE, GPS_UNLOCKED, GPS_LOCKED, GPS_NOT_APPLICABLE, RAM_ON, RAM_OFF, RSSI_ON, RSSI_OFF, TEMPERATURE_ON, TEMPERATURE_OFF, START, SHUTDOWN, RESTART, POWER_LOST, AUTOMATIC_SYSTEM_RESTORATION, AUTOMATIC_SYSTEM_RESTORATION_FACTORY, PREVIOUS_CONFIG_RESTORATION, HELLO, SNMP_AUTHENTICATION_FAILURE, CONNECTED, DISCONNECTED} (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<GatewayEventDto>> getFleetEventsWithHttpInfo(String endDate, Long id, String startDate, String fields, String page, String pageSize, String type) throws ApiException {
        com.squareup.okhttp.Call call = getFleetEventsValidateBeforeCall(endDate, id, startDate, fields, page, pageSize, type, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayEventDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getFleetEvents (asynchronously)
     * This web service allows to retrieve the list of the events of one fleet.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param endDate The end date of the period (required)
     * @param id Fleet identifier (required)
     * @param startDate The start date of the period (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param type Event type :  {CPU_ON, CPU_OFF, DISK_SYSTEM_ON, DISK_SYSTEM_OFF, DISK_USER_ON, DISK_USER_OFF, DOOR_OPEN, DOOR_CLOSED, DOOR_NOT_APPLICABLE, GPS_UNLOCKED, GPS_LOCKED, GPS_NOT_APPLICABLE, RAM_ON, RAM_OFF, RSSI_ON, RSSI_OFF, TEMPERATURE_ON, TEMPERATURE_OFF, START, SHUTDOWN, RESTART, POWER_LOST, AUTOMATIC_SYSTEM_RESTORATION, AUTOMATIC_SYSTEM_RESTORATION_FACTORY, PREVIOUS_CONFIG_RESTORATION, HELLO, SNMP_AUTHENTICATION_FAILURE, CONNECTED, DISCONNECTED} (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getFleetEventsAsync(String endDate, Long id, String startDate, String fields, String page, String pageSize, String type, final ApiCallback<PaginatedDto<GatewayEventDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getFleetEventsValidateBeforeCall(endDate, id, startDate, fields, page, pageSize, type, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayEventDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getFleetLastEvents
     * @param id Fleet identifier (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getFleetLastEventsCall(Long id, String fields, String page, String pageSize, String search, String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/fleets/{id}/events/last"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("pageSize", pageSize));
        if (search != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("search", search));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getFleetLastEventsValidateBeforeCall(Long id, String fields, String page, String pageSize, String search, String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getFleetLastEvents(Async)");
        }
        
        com.squareup.okhttp.Call call = getFleetLastEventsCall(id, fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getFleetLastEvents
     * This web service allows to retrieve the last events attached to all the gateways belonging to a fleet.&lt;br&gt;An event can be an alarm or a notification or both, depends on its value.&lt;br&gt;For example, a disconnection will produce an alarm but a reconnection will produce a notification.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Fleet identifier (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<LastEventDto> getFleetLastEvents(Long id, String fields, String page, String pageSize, String search, String sort) throws ApiException {
        ApiResponse<PaginatedDto<LastEventDto>> resp = getFleetLastEventsWithHttpInfo(id, fields, page, pageSize, search, sort);
        return resp.getData();
    }

    /**
     * getFleetLastEvents
     * This web service allows to retrieve the last events attached to all the gateways belonging to a fleet.&lt;br&gt;An event can be an alarm or a notification or both, depends on its value.&lt;br&gt;For example, a disconnection will produce an alarm but a reconnection will produce a notification.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Fleet identifier (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<LastEventDto>> getFleetLastEventsWithHttpInfo(Long id, String fields, String page, String pageSize, String search, String sort) throws ApiException {
        com.squareup.okhttp.Call call = getFleetLastEventsValidateBeforeCall(id, fields, page, pageSize, search, sort, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<LastEventDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getFleetLastEvents (asynchronously)
     * This web service allows to retrieve the last events attached to all the gateways belonging to a fleet.&lt;br&gt;An event can be an alarm or a notification or both, depends on its value.&lt;br&gt;For example, a disconnection will produce an alarm but a reconnection will produce a notification.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Fleet identifier (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getFleetLastEventsAsync(Long id, String fields, String page, String pageSize, String search, String sort, final ApiCallback<PaginatedDto<LastEventDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getFleetLastEventsValidateBeforeCall(id, fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<LastEventDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getFleetLastEventsCounters
     * @param id Fleet identifier (required)
     * @param fields List of fields to display (optional)
     * @param search Search condition (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getFleetLastEventsCountersCall(Long id, String fields, String search, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/fleets/{id}/events/last/counters"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (search != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("search", search));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getFleetLastEventsCountersValidateBeforeCall(Long id, String fields, String search, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getFleetLastEventsCounters(Async)");
        }
        
        com.squareup.okhttp.Call call = getFleetLastEventsCountersCall(id, fields, search, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getFleetLastEventsCounters
     * This web service allows to retrieve all the unread last events counters attached to a fleet.&lt;br&gt;The result is composed of the fleet and the list of its last events counters.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Fleet identifier (required)
     * @param fields List of fields to display (optional)
     * @param search Search condition (optional)
     * @return FleetLastEventCounterDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public FleetLastEventCounterDto getFleetLastEventsCounters(Long id, String fields, String search) throws ApiException {
        ApiResponse<FleetLastEventCounterDto> resp = getFleetLastEventsCountersWithHttpInfo(id, fields, search);
        return resp.getData();
    }

    /**
     * getFleetLastEventsCounters
     * This web service allows to retrieve all the unread last events counters attached to a fleet.&lt;br&gt;The result is composed of the fleet and the list of its last events counters.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Fleet identifier (required)
     * @param fields List of fields to display (optional)
     * @param search Search condition (optional)
     * @return ApiResponse&lt;FleetLastEventCounterDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<FleetLastEventCounterDto> getFleetLastEventsCountersWithHttpInfo(Long id, String fields, String search) throws ApiException {
        com.squareup.okhttp.Call call = getFleetLastEventsCountersValidateBeforeCall(id, fields, search, null, null);
        Type localVarReturnType = new TypeToken<FleetLastEventCounterDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getFleetLastEventsCounters (asynchronously)
     * This web service allows to retrieve all the unread last events counters attached to a fleet.&lt;br&gt;The result is composed of the fleet and the list of its last events counters.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Fleet identifier (required)
     * @param fields List of fields to display (optional)
     * @param search Search condition (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getFleetLastEventsCountersAsync(Long id, String fields, String search, final ApiCallback<FleetLastEventCounterDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getFleetLastEventsCountersValidateBeforeCall(id, fields, search, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<FleetLastEventCounterDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getFleetLastOperations
     * @param id Fleet identifier (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getFleetLastOperationsCall(Long id, String fields, String page, String pageSize, String search, String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/fleets/{id}/lastOperations"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("pageSize", pageSize));
        if (search != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("search", search));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getFleetLastOperationsValidateBeforeCall(Long id, String fields, String page, String pageSize, String search, String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getFleetLastOperations(Async)");
        }
        
        com.squareup.okhttp.Call call = getFleetLastOperationsCall(id, fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getFleetLastOperations
     * This web service allows to retrieve the last operations attached to one fleet.&lt;br&gt;An operation is an action done on a gateway (example : command line, get configuration, set control, ....&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Fleet identifier (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<LastOperationDto> getFleetLastOperations(Long id, String fields, String page, String pageSize, String search, String sort) throws ApiException {
        ApiResponse<PaginatedDto<LastOperationDto>> resp = getFleetLastOperationsWithHttpInfo(id, fields, page, pageSize, search, sort);
        return resp.getData();
    }

    /**
     * getFleetLastOperations
     * This web service allows to retrieve the last operations attached to one fleet.&lt;br&gt;An operation is an action done on a gateway (example : command line, get configuration, set control, ....&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Fleet identifier (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<LastOperationDto>> getFleetLastOperationsWithHttpInfo(Long id, String fields, String page, String pageSize, String search, String sort) throws ApiException {
        com.squareup.okhttp.Call call = getFleetLastOperationsValidateBeforeCall(id, fields, page, pageSize, search, sort, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<LastOperationDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getFleetLastOperations (asynchronously)
     * This web service allows to retrieve the last operations attached to one fleet.&lt;br&gt;An operation is an action done on a gateway (example : command line, get configuration, set control, ....&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Fleet identifier (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getFleetLastOperationsAsync(Long id, String fields, String page, String pageSize, String search, String sort, final ApiCallback<PaginatedDto<LastOperationDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getFleetLastOperationsValidateBeforeCall(id, fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<LastOperationDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getFleetLastStatistics
     * @param id Fleet identifier (required)
     * @param metricNames A comma separated list of metric names. {ALTITUDE, CPU, EXTRA_DISK, GPS_LOCK_RATIO, GPS_SATELLITES_NUMBER, LATITUDE, LONGITUDE, RAM, RSSI, SUPPLY_POWER_MILLI_VOLT, SYSTEM_DISK, TEMPERATURE, USER_DISK} (required)
     * @param ranges Ranges values ranges: min,max; ? min,max Example: 10,20 means 10 ? value ? 20 min: integer or null max: integer or null null means no limit. For example null,10 means value ? 10 35,null means value &gt;&#x3D; 35 (required)
     * @param fields List of fields to display (optional)
     * @param search Search condition (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getFleetLastStatisticsCall(Long id, String metricNames, String ranges, String fields, String search, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/fleets/{id}/lastStatistics"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (metricNames != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("metricNames", metricNames));
        if (ranges != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("ranges", ranges));
        if (search != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("search", search));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getFleetLastStatisticsValidateBeforeCall(Long id, String metricNames, String ranges, String fields, String search, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getFleetLastStatistics(Async)");
        }
        // verify the required parameter 'metricNames' is set
        if (metricNames == null) {
            throw new ApiException("Missing the required parameter 'metricNames' when calling getFleetLastStatistics(Async)");
        }
        // verify the required parameter 'ranges' is set
        if (ranges == null) {
            throw new ApiException("Missing the required parameter 'ranges' when calling getFleetLastStatistics(Async)");
        }
        
        com.squareup.okhttp.Call call = getFleetLastStatisticsCall(id, metricNames, ranges, fields, search, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getFleetLastStatistics
     * This web service allows to retrieve the last statistics of one fleet.&lt;br&gt;The statisitics consists of counting the number of gateways for which a numeric metric belongs to a range.&lt;br&gt;The statistic of each metric concerns the average value.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Fleet identifier (required)
     * @param metricNames A comma separated list of metric names. {ALTITUDE, CPU, EXTRA_DISK, GPS_LOCK_RATIO, GPS_SATELLITES_NUMBER, LATITUDE, LONGITUDE, RAM, RSSI, SUPPLY_POWER_MILLI_VOLT, SYSTEM_DISK, TEMPERATURE, USER_DISK} (required)
     * @param ranges Ranges values ranges: min,max; ? min,max Example: 10,20 means 10 ? value ? 20 min: integer or null max: integer or null null means no limit. For example null,10 means value ? 10 35,null means value &gt;&#x3D; 35 (required)
     * @param fields List of fields to display (optional)
     * @param search Search condition (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<GatewaysStatisticDto> getFleetLastStatistics(Long id, String metricNames, String ranges, String fields, String search) throws ApiException {
        ApiResponse<PaginatedDto<GatewaysStatisticDto>> resp = getFleetLastStatisticsWithHttpInfo(id, metricNames, ranges, fields, search);
        return resp.getData();
    }

    /**
     * getFleetLastStatistics
     * This web service allows to retrieve the last statistics of one fleet.&lt;br&gt;The statisitics consists of counting the number of gateways for which a numeric metric belongs to a range.&lt;br&gt;The statistic of each metric concerns the average value.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Fleet identifier (required)
     * @param metricNames A comma separated list of metric names. {ALTITUDE, CPU, EXTRA_DISK, GPS_LOCK_RATIO, GPS_SATELLITES_NUMBER, LATITUDE, LONGITUDE, RAM, RSSI, SUPPLY_POWER_MILLI_VOLT, SYSTEM_DISK, TEMPERATURE, USER_DISK} (required)
     * @param ranges Ranges values ranges: min,max; ? min,max Example: 10,20 means 10 ? value ? 20 min: integer or null max: integer or null null means no limit. For example null,10 means value ? 10 35,null means value &gt;&#x3D; 35 (required)
     * @param fields List of fields to display (optional)
     * @param search Search condition (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<GatewaysStatisticDto>> getFleetLastStatisticsWithHttpInfo(Long id, String metricNames, String ranges, String fields, String search) throws ApiException {
        com.squareup.okhttp.Call call = getFleetLastStatisticsValidateBeforeCall(id, metricNames, ranges, fields, search, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewaysStatisticDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getFleetLastStatistics (asynchronously)
     * This web service allows to retrieve the last statistics of one fleet.&lt;br&gt;The statisitics consists of counting the number of gateways for which a numeric metric belongs to a range.&lt;br&gt;The statistic of each metric concerns the average value.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Fleet identifier (required)
     * @param metricNames A comma separated list of metric names. {ALTITUDE, CPU, EXTRA_DISK, GPS_LOCK_RATIO, GPS_SATELLITES_NUMBER, LATITUDE, LONGITUDE, RAM, RSSI, SUPPLY_POWER_MILLI_VOLT, SYSTEM_DISK, TEMPERATURE, USER_DISK} (required)
     * @param ranges Ranges values ranges: min,max; ? min,max Example: 10,20 means 10 ? value ? 20 min: integer or null max: integer or null null means no limit. For example null,10 means value ? 10 35,null means value &gt;&#x3D; 35 (required)
     * @param fields List of fields to display (optional)
     * @param search Search condition (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getFleetLastStatisticsAsync(Long id, String metricNames, String ranges, String fields, String search, final ApiCallback<PaginatedDto<GatewaysStatisticDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getFleetLastStatisticsValidateBeforeCall(id, metricNames, ranges, fields, search, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewaysStatisticDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getFleets
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getFleetsCall(String fields, String page, String pageSize, String search, String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/fleets";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("pageSize", pageSize));
        if (search != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("search", search));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getFleetsValidateBeforeCall(String fields, String page, String pageSize, String search, String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = getFleetsCall(fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getFleets
     * This web service allows to get the list of the fleets.&lt;br&gt;If the connected user is not SUPER_ADMIN, only the fleets belonging to his customer are returned.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<FleetDto> getFleets(String fields, String page, String pageSize, String search, String sort) throws ApiException {
        ApiResponse<PaginatedDto<FleetDto>> resp = getFleetsWithHttpInfo(fields, page, pageSize, search, sort);
        return resp.getData();
    }

    /**
     * getFleets
     * This web service allows to get the list of the fleets.&lt;br&gt;If the connected user is not SUPER_ADMIN, only the fleets belonging to his customer are returned.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<FleetDto>> getFleetsWithHttpInfo(String fields, String page, String pageSize, String search, String sort) throws ApiException {
        com.squareup.okhttp.Call call = getFleetsValidateBeforeCall(fields, page, pageSize, search, sort, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<FleetDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getFleets (asynchronously)
     * This web service allows to get the list of the fleets.&lt;br&gt;If the connected user is not SUPER_ADMIN, only the fleets belonging to his customer are returned.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getFleetsAsync(String fields, String page, String pageSize, String search, String sort, final ApiCallback<PaginatedDto<FleetDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getFleetsValidateBeforeCall(fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<FleetDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for updateFleet
     * @param body The DTO JSON representation to put in the request body (required)
     * @param id Fleet identifier (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call updateFleetCall(FleetDto body, Long id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/gms/application/fleets/{id}"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call updateFleetValidateBeforeCall(FleetDto body, Long id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling updateFleet(Async)");
        }
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling updateFleet(Async)");
        }
        
        com.squareup.okhttp.Call call = updateFleetCall(body, id, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * updateFleet
     * This web service allows to update one fleet.&lt;br&gt;It also allows to move the fleet to another customer by defining the id field of the customer object.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;li&gt;If the customer has changed, the maximum number of gateways cannot be exceeded.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param id Fleet identifier (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void updateFleet(FleetDto body, Long id) throws ApiException {
        updateFleetWithHttpInfo(body, id);
    }

    /**
     * updateFleet
     * This web service allows to update one fleet.&lt;br&gt;It also allows to move the fleet to another customer by defining the id field of the customer object.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;li&gt;If the customer has changed, the maximum number of gateways cannot be exceeded.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param id Fleet identifier (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> updateFleetWithHttpInfo(FleetDto body, Long id) throws ApiException {
        com.squareup.okhttp.Call call = updateFleetValidateBeforeCall(body, id, null, null);
        return apiClient.execute(call);
    }

    /**
     * updateFleet (asynchronously)
     * This web service allows to update one fleet.&lt;br&gt;It also allows to move the fleet to another customer by defining the id field of the customer object.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;li&gt;If the customer has changed, the maximum number of gateways cannot be exceeded.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param id Fleet identifier (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateFleetAsync(FleetDto body, Long id, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateFleetValidateBeforeCall(body, id, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
}
